'use strict';
angular.module('aom.directives')
  .directive('aomDateAndTime', function ($timeout, aomResourcesSrv, constants, aomBackSrv) {
    return {
      scope: {
        field: '=',
        changedMethod: '=',
        shared: '=',
        readonly: '='
      },
      link: function ($scope) {
        function mobiscrollShown(event, inst) {
          inst.position();
        }

        function addSettings() {
          var options = { onShow: mobiscrollShown, showOnTap: false };
          var buttonTexts = { setText: aomResourcesSrv.data.resources.Common.Done, cancelText: aomResourcesSrv.data.resources.Common.Cancel, clearText: aomResourcesSrv.data.resources.Common.Clear };
          $scope.field.mobiscrollSettings = angular.extend({}, options, constants.dateSettings, constants.dateAndTimeTimeSettings, buttonTexts);
        }

        function closeModal(ctId) {
          aomBackSrv.exit();
          mobiscroll.instances[ctId].hide();
        }

        if ($scope.field.Data === null) {
          $scope.field.Data = '';
        } else if ($scope.field.Data !== '') {
          $scope.field.Data = moment($scope.field.Data).toDate();
        }

        if ($scope.field.Options.IsSetOnOpen) {
          $scope.field.Data = new Date;
          change();
        }

        addSettings();

        $scope.show = function ($event) {
          if ($scope.field.Options.IsReadOnly) return;
          if ($scope.field.Options.IsWriteOnce && $scope.field.Data !== '' && $scope.field.Data !== null) return;

          if ($scope.field.Options.IsSetOnTouch) {
            $scope.field.Data = new Date;
            return change();
          }

          var ctId = $event.currentTarget ? $event.currentTarget.id : $event.target.id;
          var timeoutLength = $scope.shared && $scope.shared.keyboardUp ? 500 : 0;

          $timeout(function () {
            aomBackSrv.init(closeModal(ctId));
            mobiscroll.instances[ctId].show();
          }, timeoutLength);
        };

        function change() {
          if ($scope.changedMethod !== undefined) $scope.changedMethod($scope.field.Name);

          $scope.field.DiffCallbacks.forEach(function (cb) {
            cb();
          });

          addSettings();
        }

        $scope.mobiscrollChange = change;
      },
      templateUrl: 'App/Common/Directives/DateAndTime/dateandtime.html'
    };
  });
