'use strict';
angular.module('aom.services')
  .factory('aomModalSrv', function ($ionicModal, $ionicPlatform, $timeout, $q, constants, aomPopupSrv, aomMediaSrv, aomHardwareSrv) {

    var modalSrv = {};

    var fieldTemplates = {};
    fieldTemplates[constants.fieldTypes.photoVideo] = 'App/Components/MediaList/mediaListModal.html';
    fieldTemplates[constants.fieldTypes.attachment] = 'App/Components/MediaList/mediaListModal.html';
    fieldTemplates[constants.fieldTypes.docSearch] = 'App/Components/SearchMediaList/searchMediaModal.html';
    fieldTemplates[constants.fieldTypes.signature] = 'App/Components/ImageEditor/imageEditorModal.html';
    fieldTemplates[constants.fieldTypes.freehand] = 'App/Components/ImageEditor/imageEditorModal.html';

    modalSrv.modal = {};

    function setupScreen($scope, fieldType) {
      var deregisterHardwareBackButton = null;

      function setupHardwareBackButton() {
        deregisterHardwareBackButton = $ionicPlatform.registerBackButtonAction(
          $scope.back, 201
        );
      }

      $scope.hideModal = function () {
        $timeout(function () {
          $scope.modal.hide()
            .then(function () {
              $scope.modal.remove();
            });
        });
        if ($scope.changedMethod !== undefined) {
          $scope.changedMethod();
        }
        if (fieldType !== constants.fieldTypes.signature && fieldType !== constants.fieldTypes.freehand) {
          deregisterHardwareBackButton();
        }
      };

      $scope.back = function () {
        if (fieldType === constants.fieldTypes.photoVideo) {
          if (!aomMediaSrv.data.isSelectingMedia) {
            $scope.hideModal();
          }
        } else {
          $scope.hideModal();
        }
      };
      if (fieldType !== constants.fieldTypes.signature && fieldType !== constants.fieldTypes.freehand) {
        setupHardwareBackButton();
      }
    }

    modalSrv.show = function ($scope, fieldType, fieldName) {
      $ionicModal.fromTemplateUrl(fieldTemplates[fieldType], {
        scope: $scope,
        animation: aomHardwareSrv.isTomTom() ? 'none' : 'slideToLeft'
      })
        .then(function (modal) {
          $scope.modal = modal;
          aomPopupSrv.addModal(fieldName, modal);
          modalSrv.modal = modal;
          setupScreen($scope, fieldType);
          return $q.when();
        })
        .then(function () {
          return $scope.modal.show();
        });
    };

    modalSrv.hideModal = function () {
      if (Object.keys(modalSrv.modal).length !== 0) {
        return modalSrv.modal.remove();
      } else {
        return $q.when();
      }
    };

    return modalSrv;
  });