'use strict';
angular.module('aom.services')
  .factory('aomPopupSrv', function ($ionicPopup, aomResourcesSrv) {
    var popup = {},
      popups = {},
      popupButtonPressedState = {},
      modals = {};


    popup.closeModals = function () {
      for (var modal in modals) {
        if (modals.hasOwnProperty(modal) && modal !== undefined && modal !== null) {
          modals[modal].remove();
        }
      }
    };

    popup.addModal = function (name, aModal) {
      modals[name] = aModal;
    };

    popup.closePopups = function () {
      for (var popup in popups) {
        if (popups.hasOwnProperty(popup) && popup !== undefined && popup !== null) {
          popups[popup].close();
        }
      }
    };

    popup.addPopup = function (name, aPopup) {
      popups[name] = aPopup;
    };

    popup.closePopup = function (name) {
      popups[name].close();
    };

    popup.wrapper = function (popupDef) {
      popupButtonPressedState[popupDef.id] = false;
      popupDef.buttons.map(function (button) {
        if (button.tapMethod) {
          button.onTap = function () {
            if (!popupButtonPressedState[popupDef.id]) {
              popupButtonPressedState[popupDef.id] = true;
              button.tapMethod();
            }
          };
        }
      });

      popup.addPopup(popupDef.id, $ionicPopup.show(popupDef));
    };

    popup.alert = function (name, aPopup) {
      popup.addPopup(name, $ionicPopup.alert({
        title: aPopup.title,
        template: aPopup.template,
        buttons: [
          {
            text: aomResourcesSrv.data.resources.Common.Okay,
            type: 'button-positive',
            onTap: aPopup.onDismiss
          }
        ]
      }
      ));
    };

    popup.confirm = function (name, aPopup) {
      popup.addPopup(name, $ionicPopup.alert({
        title: aPopup.title,
        template: aPopup.template,
        buttons: [
          {
            text: aomResourcesSrv.data.resources.Common.No,
            type: 'button-stable button-outline',
            onTap: aPopup.onNo
          },
          {
            text: aomResourcesSrv.data.resources.Common.Yes,
            type: 'button-positive',
            onTap: aPopup.onYes
          }
        ]
      }
      ));
    };

    return popup;
  });