'use strict';
angular.module('aom.services')
  .factory('aomSyncSrv', function ($q, aomAPISrv, aomResourcesSrv, aomUserSrv, aomLogSrv) {
    var sync = {};

    sync.data = {
      appSettings: false,
      trackingGroups: false
    };

    sync.sendAppSettings = function () {
      if (sync.data.appSettings) {
        return aomAPISrv.putData(aomResourcesSrv.data.resources.appSettingsSaveLink, aomResourcesSrv.data.resources.appConfig)
          .then(function () {
            sync.data.appSettings = false;
            return aomUserSrv.updateLastUser();
          })
          .catch(function (err) {
            aomLogSrv.log({ message: 'Could not sync the user app settings', error: err }, aomLogSrv.levels.medium, aomLogSrv.severities.err);
          });
      } else {
        return $q.when();
      }
    };

    sync.sendTrackingGroups = function () {
      if (sync.data.trackingGroups) {
        return aomAPISrv.putData(aomResourcesSrv.data.resources.appSettingsSaveLink, aomResourcesSrv.data.resources.appConfig)
          .then(function () {
            sync.data.trackingGroups = false;
          });
      }
    };

    return sync;
  });
