angular.module('aom.services')
  .factory('aomStateSrv', function ($state, $timeout, $ionicHistory, constants, aomLogoutSrv) {
    var stateSrv = {};

    stateSrv.data = {
      main: '',
      details: '',
      fullscreen: false,
      selectedMenuItem: constants.viewStates.inbox,
      showingMap: false,
      selectedMenuItemTitle : ''
    };

    stateSrv.setRight = function setRight(view) {
      setView(constants.viewPanels.right, view);

      stateSrv.data.showingMap = (view === constants.viewStates.map);
    };

    stateSrv.setLeft = function setLeft(view) {
      stateSrv.data.selectedMenuItem = view;

      revertFullscreen();

      setView(constants.viewPanels.left, view);

      if (view === constants.viewStates.settings) {
        stateSrv.setRight(constants.viewStates.empty);
      }
    };

    stateSrv.isShowingRightPane = function isShowingRightPane() {
      return stateSrv.data.details !== constants.viewStates.empty;
    };

    stateSrv.toggleFullscreen = function toggleFullscreen() {
      stateSrv.data.fullscreen = !stateSrv.data.fullscreen;
    };

    function revertFullscreen() {
      stateSrv.data.fullscreen = false;
    }

    function setView(panel, view) {
      aomLogoutSrv.updateLastActivity();
      if (!view) view = constants.viewStates.empty;

      if (view === constants.viewStates.logout) {
        logout();
      }

      if (!isSameView(panel, view)) {
        stateSrv.data[panel] = view;
      }
    }

    function isSameView(panel, view) {
      return stateSrv.data[panel] === view;
    }

    function logout() {
      $timeout(function () {

        $state.go(constants.viewStates.logout);

        $timeout(function () {
          $ionicHistory.clearHistory();
        });
      }, 200);
    }

    return stateSrv;
  });