﻿'use strict';
angular.module('aom.directives')
  .directive('aomSettings', function ($ionicSideMenuDelegate, aomResourcesSrv, constants, aomStyleSrv, aomSyncSrv, aomStateSrv) {
    return {
      scope: {
        onSelect: '&'
      },
      link: function ($scope) {
        $scope.data = {
          resources: aomResourcesSrv.data.resources,
          rowClass: ''
        };

        setRowClass();

        function setRowClass() {
          $scope.data.rowClass = aomStyleSrv.getRowClass();
        }

        $scope.showSideMenu = function () {
          $ionicSideMenuDelegate.toggleLeft();
        };

        $scope.selectSetting = function (index) {
          $scope.selectedIndex = index;
          $scope.onSelect()(index);
          aomStateSrv.setRight(constants.viewStates.settings);
        };

        $scope.$on('updateSettingsView', function () {
          setRowClass();
        });

        $scope.$on('$destroy', function () {
          aomSyncSrv.data.appSettings = true;
          aomSyncSrv.sendAppSettings();
        });
      },
      templateUrl: 'App/Components/Settings/settings.html'
    };

  });
