angular.module('aom')
  .config(function ($stateProvider, $urlRouterProvider) {
    $stateProvider
      .state('app', { url: '/app', abstract: true, templateUrl: 'App/Components/SideMenu/sideMenu.html', controller: 'SideMenuCtrl' })
      .state('debug', { cache: false, url: '/debug', templateUrl: 'App/Components/Debug/debug.html', controller: 'DebugCtrl', resolve: {} })
      .state('logon', { cache: false, url: '/logon', templateUrl: 'App/Common/Components/Logon/logon.html', controller: 'LogonCtrl', resolve: {} })
      .state('app.Main', { cache: false, url: '/main', views: { menuContent: { templateUrl: 'App/Components/Main/main.html', controller: 'MainCtrl' } }, resolve: {} })
      .state('app.Barcode', { cache: false, url: '/barcode', views: { menuContent: { controller: 'BarcodeCtrl' } }, resolve: {} })
      .state('app.ImageEditor', { cache: false, url: '/imageEditor', views: { menuContent: { templateUrl: 'App/Components/ImageEditor/imageEditor.html', controller: 'ImageEditorCtrl' } }, resolve: {} })
      .state('app.MediaList', { cache: false, url: '/mediaList', views: { menuContent: { templateUrl: 'App/Components/MediaList/mediaList.html', controller: 'MediaListCtrl' } }, resolve: {} })
      .state('app.SearchMediaList', { cache: false, url: '/searchMediaList', views: { menuContent: { templateUrl: 'App/Components/SearchMediaList/searchMediaList.html', controller: 'SearchMediaListCtrl' } }, resolve: {} })
      .state('app.Templates', { cache: true, url: '/templates', views: { menuContent: { templateUrl: 'App/Components/Jobs/jobs.html', controller: 'JobsCtrl' } }, resolve: { stateData: function (aomJobsSrv) { return aomJobsSrv.dataForTemplates(); } } });

    $urlRouterProvider.otherwise('/logon');
  });